#import "LvnsController.h"
#import "MOXAudioLVNS.h"

#define TICKSPERSEC 1.0

@implementation LvnsController

// NSView ᥽åɷ

/*  */
- (void) drawRect : (NSRect) arBounds
{
	[image draw:arBounds];
}

// ٥Ƚ

- (void)mouseMoved:(NSEvent *)theEvent
{
	NSPoint pos = [theEvent locationInWindow];
	LvnsMotion(lvns, pos.x, HEIGHT-pos.y);
}

- (void)mouseDown:(NSEvent *)theEvent
{
	[self Select:self];
}

- (void)rightMouseDown:(NSEvent *)theEvent
{
	[self Cancel:self];
} 

- (void)keyDown:(NSEvent *)theEvent
{
}

- (BOOL)acceptsFirstResponder
{
    return YES;
}

// actions 

- (IBAction) Select : (id) sender
{
	LvnsSelect(lvns);
}

- (IBAction) Cancel : (id) sender
{
	LvnsCancel(lvns);
}

- (IBAction) ImageMode : (id) sender
{
}

- (IBAction) SkipTillSelect : (id) sender
{
}

- (IBAction) SkipTillSelectForce : (id) sender
{
}

- (IBAction) CursorUp : (id) sender
{
	LvnsCursorUp(lvns);
}

- (IBAction) CursorDown : (id) sender
{
	LvnsCursorDown(lvns);
}

// privates

// Lvns System Depend Functions

/** 
 * ̤եå夷Ƽºݤβ̤ȿǤ
 */
static void 
FlushWindow(Lvns *lvns)
{
	LvnsController *self = lvns->system_depend;
	[self display];
}

/**
 * ̤ʬŪ˥եå夷Ƽºݤβ̤ȿǤ
 */
static void
FlushWindowArea(Lvns *lvns, int x, int y, int w, int h)
{
	LvnsController *self = lvns->system_depend;
//	[self setNeedsDisplayInRect:NSMakeRect(x,HEIGHT-(y+h),w,h)];
	[self displayRect:NSMakeRect(x,HEIGHT-(y+h),w,h)];
	//[self lockFocus];
	//[self->image draw : NSMakeRect(x,HEIGHT-(y+h),w,h)];
	//[self unlockFocus];
}

/**
 * Τ(եå̵) 
 */
static void
DrawWindow(Lvns *lvns) 
{
	LvnsController *self = lvns->system_depend;
	[self->image copy:lvns->vram : 0 : 0];
}

/**
 * ʬ(եå̵) 
 */
static void
DrawWindowArea(Lvns *lvns, int x, int y, int w, int h, int x2, int y2)
{
	LvnsController *self = lvns->system_depend;
	[self->image copyArea:lvns->vram : x : y : w : h : x2 : y2];
}

/**
 * ̲̾õ(եå̵)
 */
static void
ClearWindow(Lvns *lvns)
{
	LvnsController *self = lvns->system_depend;
	[self->image clearArea: 0 : 0 : WIDTH : HEIGHT : lvns->vram->black];
}

/**
 * ʬ̾õ(եå̵)
 */
static void
ClearWindowArea(Lvns *lvns, int x, int y, int w, int h)
{
	LvnsController *self = lvns->system_depend;
	[self->image clearArea: x : y : w : h : lvns->vram->black];
}

/**
 * Υǥå˥顼Ƥ
 */
static void
SetPaletteIndex(Lvns *lvns, int index, int r, int g, int b)
{
	LvnsController *self = lvns->system_depend;
	[self->image setPalette:index r:r g:g b:b];
}

/**
 * ѥå(̾)
 * ꤹ
 */
static void
MySetPalette(Lvns *lvns)
{
	LvnsController *self = lvns->system_depend;
	[self->image setPal:lvns->vram];
}

/**
 * ѥå(multiple)
 */
static void
SetPaletteMulti(Lvns *lvns, int par16)
{
	LvnsController *self = lvns->system_depend;
	[self->image setPalMulti:lvns->vram :par16];
}

/**
 * ѥå(screen)
 */
static void
SetPaletteScreen(Lvns *lvns, int par16)
{
	LvnsController *self = lvns->system_depend;
	[self->image setPalScreen:lvns->vram :par16];
}

/* 
 * ޥѥǥɥФԤ(եå̵)
 */
static void
DrawWindowMask(Lvns *lvns, int x, int y, int state)
{
	LvnsController *self = lvns->system_depend;
	[self->image copyMaskUnit:lvns->vram : x : y : x : y : state ];
}

/* 
 * ѥǥɥФԤ(եå̵)
 */
static void
DrawWindowSquareMask(Lvns *lvns, int x, int y, int state)
{
	LvnsController *self = lvns->system_depend;
	[self->image copySquareMaskUnit:lvns->vram : x : y : x : y : state];
}

/*
 * ɽƤ̤ΥեåȤ򤺤餹(ư)
 */
static void
SetDispOffset(Lvns *lvns, int xoff, int yoff, int maxoff)
{
}

/* 
 * ʸѥɽ (/ )
 */
static void
PutPattern(Lvns *lvns, int x, int y, int index, u_char *data)
{
	LvnsController *self = lvns->system_depend;
	[self->image putPattern24_2:x :y :index :data];
}

/* 
 * ʸѥɽ (ToHeart)
 */ 
static void 
PutPattern2(Lvns *lvns, int x, int y, int index, u_char *data)
{
	LvnsController *self = lvns->system_depend;
	[self->image putPattern24:x :y :index :data];
}

/* 
 * ޤꥻåȤ
 * @param no ֹ
 */
static void
ResetTimer(Lvns *lvns, int no)
{
	LvnsController *self = lvns->system_depend;
    gettimeofday(&self->timer[no], NULL);
}

/*
 * ͤ
 * @param no ֹ
 * @return  (msecñ)
 */	// 󥯥
	// 󥯥

static long 
GetTimer(Lvns *lvns, int no)
{
	LvnsController *self = lvns->system_depend;
	struct timeval current;
    gettimeofday(&current, NULL);
    return (current.tv_sec - self->timer[no].tv_sec) * 1000 +
        (current.tv_usec - self->timer[no].tv_usec) / 1000;
}

/**
 * 褹
 * @param x,y,w,h ֤ȥ
 * @param idx Υǥå
 */
static void
DrawBox(Lvns *lvns, int x, int y, int w, int h, int idx)
{
}

#include <sys/types.h>
#include <sys/stat.h>

/** 
 * ꤷեιդ
 */
static time_t
GetFileTime(Lvns *lvns, const char *path)
{
    struct stat sb;
    if (stat(path, &sb) < 0) {
        return 0;
    }
    return sb.st_mtime;
}

/**
 * Ʊ
 */
- (void) flip
{
	NSTimeInterval wait, sa;

	// ޥ֥å
	//NSPoint pos = [NSEvent mouseLocation];
	//NSRect rect = [[self window] frame];
	//if ([self mouse:pos inRect:rect]) {
//		pos.x -= rect.origin.x;
//		pos.y -= rect.origin.y;
//		LvnsMotion(lvns, pos.x, HEIGHT-pos.y);
//	}

	wait = wait_count / 60.0;
	if (wait > 0) {
		NSTimeInterval tw;
		sa = [NSDate timeIntervalSinceReferenceDate] - wait_clock;
		if (sa > 0) wait -= sa;
		if (wait > 0) {
			NSDate *date = [[NSDate alloc] initWithTimeIntervalSinceNow: wait];
			[NSThread sleepUntilDate : date];
			[date release];
		}
		tw = [NSDate timeIntervalSinceReferenceDate];
		sa = tw - wait_clock;
		if (sa > 0) 
			wait_count -= sa * 60.0;
		else 
			wait_count = 0;
		wait_clock = tw;
	}
	wait_count += TICKSPERSEC;
	if (wait_count < 0) {
		wait_count = 0;
	}
}

/*
 * 西ߥԤ
 */
static void
Flip(Lvns *lvns)
{
	LvnsController *self = lvns->system_depend;
	[self flip];
}

/**
 * ᥤ󥨥󥸥 
 */
- (void) runMain : (id) param
{
    LvnsMain(lvns);
}

extern int system_type;

/**
 * 
 */
- (void) applicationDidFinishLaunching:(NSNotification *)aNotification
{
    char *home = getenv("HOME");
    lvns = LvnsNew();

	if (home) {
		LvnsSetSaveDataPath(lvns, home);
	}
	//LvnsSetDataPath(lvns, );

	/* ꥽ȿ */
	lvns->demo_mode        = False;
	lvns->seen_mode        = True;
	lvns->latitude_dark    = 11;
	lvns->key_click_fast   = True;

	/* ƥ¸ؿ */
	lvns->flushWindow          = FlushWindow;
	lvns->flushWindowArea      = FlushWindowArea;
	lvns->drawWindow           = DrawWindow;
	lvns->drawWindowArea       = DrawWindowArea;
	lvns->clearWindow          = ClearWindow;
	lvns->clearWindowArea      = ClearWindowArea;
	lvns->setPaletteIndex      = SetPaletteIndex;
	lvns->setPalette           = MySetPalette;
	lvns->setPaletteMulti      = SetPaletteMulti;
	lvns->setPaletteScreen     = SetPaletteScreen;
	lvns->drawWindowMask       = DrawWindowMask;
	lvns->drawWindowSquareMask = DrawWindowSquareMask;
	lvns->setDispOffset        = SetDispOffset;
	lvns->putPattern           = PutPattern;
	lvns->putPattern2          = PutPattern2;
	lvns->resetTimer           = ResetTimer;
	lvns->getTimer             = GetTimer;
	lvns->drawBox              = DrawBox;
	lvns->getFileTime          = GetFileTime;
	lvns->flip                 = Flip;

	// BGM
	lvns->sound = [MOXAudioLVNS getSound:lvns];

	LvnsInitialize(lvns, system_type, self);

	//
	{
		NSSize size = { WIDTH, HEIGHT };
		[mainWindow setContentSize:size];
		[mainWindow setContentView:self];
		image = [[NSLvnsImage alloc] init:size];
	}

	[mainWindow setAcceptsMouseMovedEvents:YES];	

	wait_clock = [NSDate timeIntervalSinceReferenceDate];
	wait_count = TICKSPERSEC;

	// åɤʬΤư
	[NSThread detachNewThreadSelector:@selector(runMain:) toTarget:self withObject:self];
}

@end

