/*
 * LEAF Visual Novel System For X
 * (c) Copyright 1999,2000 Go Watanabe mailto:go@denpa.org
 * All rights reserverd.
 *
 * ORIGINAL LVNS (c) Copyright 1996-1999 LEAF/AQUAPLUS Inc.
 *
 * $Id: LvnsCoreDepend.c,v 1.1 2002/07/29 05:03:30 go Exp $
 */

/*
 * Ķ˰¸ƼԤδؿϡĶȤ
 * ľɬפ롣
 * lvns->system_depend ˴Ķ¸äƤΤ
 * 򻲾Ȥ뤳ȤǤ롣
 */

#include <stdio.h>
#include <stdlib.h>

#include "LvnsCoreP.h"
#include "LvnsInfo.h"
#include "lvnsimage_sximage.h"

/* ---------------------------------------------------------------- */

/*
 *  VRAM 
 */

/* 
 * ̤եå夷Ƽºݤβ̤ȿǤ
 */
void
LvnsFlushWindow(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_set_pixmap_area(LCW.sximage, 0, 0, WIDTH, HEIGHT);
    super_ximage_copy_area_win(LCW.sximage, 0, 0, WIDTH, HEIGHT);
    super_ximage_sync(LCW.sximage);
}

/*
 * ̤ʬŪ˥եå夷Ƽºݤβ̤ȿǤ
 */
void
LvnsFlushWindowArea(LvnsInfo *lvns, int x, int y, int w, int h)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
#if 0
    dprintf((stderr, "FlushWindow %d %d %d %d\n", x, y, w, h));
#endif
    super_ximage_set_pixmap_area(LCW.sximage, x, y, w, h);
    super_ximage_copy_area_win(LCW.sximage, x, y, w, h);
}

void
LvnsSyncWindow(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_sync(LCW.sximage);
}

/* Τ(եå̵) */
void
LvnsDrawWindow(LvnsInfo *lvns) 
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_copy_to_sximage(lvns->vram, LCW.sximage, 0, 0);
}

/* ʬ(եå̵) */
void
LvnsDrawWindowArea(LvnsInfo *lvns, int x, int y, int w, int h, int x2, int y2)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_copy_area_to_sximage(lvns->vram, LCW.sximage, x, y, w, h, x2, y2);
}

/*
 * ̲̾õ(եå̵)
 */
void
LvnsClearWindow(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_clear_area(LCW.sximage, 0, 0, WIDTH, HEIGHT,
                            LCW.sximage->pixels[lvns->vram->black]);
}

/*
 * ʬ̾õ(եå̵)
 */
void
LvnsClearWindowArea(LvnsInfo *lvns, int x, int y, int w, int h)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_clear_area(LCW.sximage, x, y, w, h,
                            LCW.sximage->pixels[lvns->vram->black]);
}

/*
 * Υǥå˥顼Ƥ
 */
void
LvnsSetPaletteIndex(LvnsInfo *lvns, int index, int r, int g, int b)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_set_palette(LCW.sximage, index, r, g, b);
}

/*
 * ѥå(̾)
 * ꤹ
 */
void
LvnsSetPalette(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_set_pal_to_sximage(lvns->vram, LCW.sximage);
}

/*
 * ѥå(multiple)
 */
void
LvnsSetPaletteMulti(LvnsInfo *lvns, int par16)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_set_pal_to_sximage_multi(lvns->vram, LCW.sximage, par16);
}

/*
 * ѥå(screen)
 */
void
LvnsSetPaletteScreen(LvnsInfo *lvns, int par16)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_set_pal_to_sximage_screen(lvns->vram, LCW.sximage, par16);
}

/* 
 * ޥѥǥɥФԤ(եå̵)
 */
void
LvnsDrawWindowMask(LvnsInfo *lvns, int x, int y, int state)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_copy_mask_unit_to_sximage(lvns->vram, LCW.sximage, 
                                        x, y, state);
}

/* 
 * ѥǥɥФԤ(եå̵)
 */
void
LvnsDrawWindowSquareMask(LvnsInfo *lvns, int x, int y, int state)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    lvnsimage_copy_squaremask_unit_to_sximage(lvns->vram, LCW.sximage, 
                                              x, y, state);
}

/*
 * ɽƤ̤ΥեåȤ򤺤餹(ư)
 */
void
LvnsSetDispOffset(LvnsInfo *lvns, int xoff, int yoff, int maxoff)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
#if 0
    super_ximage_clear_area_win(LCW.sximage, -maxoff, -maxoff, 
                                maxoff*2, HEIGHT+maxoff*2,
                                LCW.sximage->pixels[lvns->vram->black]);
    super_ximage_clear_area_win(LCW.sximage, -maxoff, -maxoff, 
                                WIDTH+maxoff*2, maxoff*2,
                                LCW.sximage->pixels[lvns->vram->black]);
    super_ximage_clear_area_win(LCW.sximage, +WIDTH-maxoff, 0, 
                                maxoff*2, HEIGHT+maxoff,
                                LCW.sximage->pixels[0]);
    super_ximage_clear_area_win(LCW.sximage, 0, +HEIGHT-maxoff, 
                                WIDTH+maxoff, maxoff*2,
                                LCW.sximage->pixels[lvns->vram->black]);
#endif
    super_ximage_copy_area_win2(LCW.sximage, -maxoff*2, -maxoff*2, WIDTH+maxoff*4, HEIGHT+maxoff*4, -maxoff*2 + xoff, -maxoff*2 + yoff);
    super_ximage_sync(LCW.sximage);
}

/* 
 * ʸѥɽ (/ )
 */
void
LvnsPutPattern(LvnsInfo *lvns, int x, int y, int index, u_char *data)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_put_pattern24_2(LCW.sximage, 
                                 x, y, LCW.sximage->pixels[index], data);
}

/* 
 * ʸѥɽ (ToHeart )
 */
void
LvnsPutPattern2(LvnsInfo *lvns, int x, int y, int index, u_char *data)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    super_ximage_put_pattern24(LCW.sximage, 
                               x, y, LCW.sximage->pixels[index], data);
}

/* 
 * ޤꥻåȤ
 */
void
LvnsResetTimer(LvnsInfo *lvns, int no)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    gettimeofday(&LCW.timer[no], NULL);
}

/*
 * ͤ
 */
long 
LvnsGetTimer(LvnsInfo *lvns, int no)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    struct timeval current;
    gettimeofday(&current, NULL);
    return (current.tv_sec - LCW.timer[no].tv_sec) * 1000 +
        (current.tv_usec - LCW.timer[no].tv_usec) / 1000;
}

/* ---------------------------------------------------------------- */

/*
 * ᥤ󥸥ϡLvnsCoreMainEngine()
 *
 * ʥꥪ˾ܤ
 * ͤοäˤϤλַв
 * 
 * ˸ƤӽФ
 * 
 *
 * LvnsStartEngine() Ƥ֤ȡν롼פ
 * LvnsMainEngine ƤӽФ褦ꤹ뤳
 *
 * LvnsStopEngine ϽǤԤ
 * 
 * ᥤνǤϡLvnsMainEngine() ƤӽФ
 * ͤåƼθƤӽФꤹ
 */

/*
 * ᥤ󥸥(Ԥư)
 */
static void
MainEngine(XtPointer cl, XtIntervalId * id)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget) cl;
    LvnsInfo *lvns  = &LCW.info;
    long waittime;
    struct timeval starttp;

    /* Ѥλ֤μ */
    gettimeofday(&starttp, NULL);

#if 0
    dprintf((stderr, "MainEngine\n"));
#endif

    /* Ԥּ */
    waittime = LvnsMainEngine(lvns);

    /* Ԥ֤ξϼθƤӽФ */
    if (waittime >= 0) {

        XtAppContext    app = XtWidgetToApplicationContext((Widget)lcw);

        /* Ԥ֤ */
        struct timeval curtp;
        long msec;

        gettimeofday(&curtp, NULL);
        msec = (curtp.tv_sec - starttp.tv_sec) * 1000 +
            (curtp.tv_usec - starttp.tv_usec) / 1000;
        
        if ((waittime -= msec) < 0)
            waittime = 0;

#if defined(__FreeBSD__)
        /* 
         * FreeBSD ޤ٤Τ
         *  (T_T)
         */
        waittime += LCW.wait_add;
        LCW.wait_add = 0;
        if (waittime < 10) {
            LCW.wait_add = waittime;
            waittime = 0;
        }
#endif
        LCW.timewait_id = 
            XtAppAddTimeOut(app, waittime, MainEngine, lcw);
    } else {
        LCW.timewait_id = None;
    }
    
}

/*
 * ᥤ󥸥εư 
 * Ϣν뤷ν롼פǥ󥸥ƤӽФѻ
 */
void
LvnsStartEngine(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    if (LCW.timewait_id == None) {
        XtAppContext    app = XtWidgetToApplicationContext((Widget)lcw);
        LCW.timewait_id = XtAppAddTimeOut(app, 0, MainEngine, lcw);
    }
}

/*
 * ᥤ󥸥 
 * ƤӽФͽ󤬤äƤ륨󥸥ߤ
 */
void
LvnsStopEngine(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    if (LCW.timewait_id) {
	XtRemoveTimeOut(LCW.timewait_id);
        LCW.timewait_id = None;
    }
}

/* λ */
void
LvnsEnd(LvnsInfo *lvns)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    XtAppSetExitFlag(XtWidgetToApplicationContext((Widget)lcw));
}

void
LvnsDrawBox(LvnsInfo *lvns, int x, int y, int w, int h, int idx)
{
    LvnsCoreWidget lcw = (LvnsCoreWidget)lvns->system_depend;
    sximage_box(LCW.sximage, x, y, w, h, idx);
}

#include <sys/types.h>
#include <sys/stat.h>

time_t
LvnsGetFileTime(LvnsInfo *lvns, const char *path)
{
    struct stat sb;
    if (stat(path, &sb) < 0) {
        perror(path);
        return 0;
    }
    return sb.st_mtime;
}
