/*
 * LEAF Visual Novel System For X
 * (c) Copyright 1999,2000 Go Watanabe mailto:go@denpa.org
 * All rights reserverd.
 *
 * ORIGINAL LVNS (c) Copyright 1996-1999 LEAF/AQUAPLUS Inc.
 *
 * $Id: LvnsDisp.c,v 1.1 2002/07/29 05:24:38 go Exp $
 *
 */

/*
 * Lvns ɽ
 */

#include <stdio.h>
#include "Lvns.h"
#include "LvnsEffect.h"

/**
 * ߤΥƥȥ쥤褹
 */
static void
DrawTextLayerAll(Lvns *lvns)
{
    int i, j;
    for (i=0; i<TEXT_HEIGHT;i++) {
        for (j=0; j<TEXT_WIDTH; j++) {
            struct TextVram *c = 
                &lvns->tvram[lvns->current_tvram].row[i].column[j];
            if (c->code) {
                int x = XPOS(j,i);
                int y = YPOS(i);
				LVNS->drawChar(lvns, x, y, c->code, c->attribute);
            }
        }
    }
}

/*
 * ξõ
 */
void
LvnsClearCursor(Lvns *lvns)
{
    if (lvns->cursor_state) {
        int x = XPOS(lvns->tvram[lvns->current_tvram].o_cur_x, 
                     lvns->tvram[lvns->current_tvram].o_cur_y);
        int y = YPOS(lvns->tvram[lvns->current_tvram].o_cur_y); 
        lvns->drawWindowArea(lvns, x, y, CHARDRAWSIZE, CHARDRAWSIZE, x, y);
        LvnsFlushWindowArea(lvns, x, y, CHARDRAWSIZE, CHARDRAWSIZE);
        lvns->cursor_state = 0;
    }
}

/*
 * 
 */
void
LvnsDrawCursor(Lvns *lvns, LvnsCursorType cursor_type)
{       
    int cursor;

    if (cursor_type == LVNS_CURSOR_PAGE) {
        cursor = LVNS->cursor_page;
    } else
        cursor = LVNS->cursor_key;

    if (lvns->cursor_state == 0) {
        int x = XPOS(lvns->tvram[lvns->current_tvram].cur_x,
                     lvns->tvram[lvns->current_tvram].cur_y);
        int y = YPOS(lvns->tvram[lvns->current_tvram].cur_y);

        LVNS->drawChar(lvns, x, y, cursor, 0);
        LvnsFlushWindowArea(lvns, x, y, CHARDRAWSIZE, CHARDRAWSIZE);

        lvns->tvram[lvns->current_tvram].o_cur_x = 
            lvns->tvram[lvns->current_tvram].cur_x;
        lvns->tvram[lvns->current_tvram].o_cur_y = 
            lvns->tvram[lvns->current_tvram].cur_y;
        
        lvns->cursor_state = 1;

    } else {
        LvnsClearCursor(lvns);
    }
}

/**
 * ƥȥξõ
 */
void
LvnsClearTextCursor(Lvns *lvns)
{
    int i, j;
    for (i=0; i<TEXT_HEIGHT;i++) {
        for (j=0; j<TEXT_WIDTH; j++) {
            struct TextVram *c = 
                &lvns->tvram[lvns->current_tvram].row[i].column[j];
            if (c->code && c->attribute == lvns->text_cursor_state) {
                int x = XPOS(j,i);
                int y = YPOS(i);
                LVNS->drawChar(lvns, x, y, c->code, 1);
                LvnsFlushWindowArea(lvns, x, y, CHARDRAWSIZE, CHARDRAWSIZE);
            }
        }
    }
}

/**
 * ƥȥɽ
 */
void
LvnsDrawTextCursor(Lvns *lvns)
{
    int i, j;
    for (i=0; i<TEXT_HEIGHT;i++) {
        for (j=0; j<TEXT_WIDTH; j++) {
            struct TextVram *c = 
                &lvns->tvram[lvns->current_tvram].row[i].column[j];
            if (c->code && c->attribute == lvns->text_cursor_state) {
                int x = XPOS(j,i);
                int y = YPOS(i);
                LVNS->drawChar(lvns, x, y, c->code, 0);
                LvnsFlushWindowArea(lvns, x, y, CHARDRAWSIZE, CHARDRAWSIZE);
            }
        }
    }
}

/**
 * ߤβ(ط + ʸ)  vram 褵
 */
void
LvnsDispWindow(Lvns *lvns)
{
	/* եå */
    lvns->setPaletteMulti(lvns, lvns->latitude);
    lvns->drawWindow(lvns);

	/* ɲɽ(˥塼ʤɤ) */
	if (lvns->disp_func) 
		lvns->disp_func(lvns, lvns->disp_func_param);

	/* ƥɽ */
    if (lvns->text_mode) {
		DrawTextLayerAll(lvns);
    }

	LvnsFlushWindow(lvns);
}

/* ʸõ */
void
LvnsUndispText(Lvns *lvns)
{
	LvnsFlip(lvns, True); // ƱΤ
	lvns->text_mode = False;
	if (lvns->skip) {
		lvns->latitude = 16;
		LvnsDispWindow(lvns);
	} else {
		LvnsLighten(lvns);
	}
}

/* ʸɽ */
void
LvnsDispText(Lvns *lvns)
{
	if (!lvns->text_mode) {
		lvns->text_mode = True;
		if (lvns->skip) {
			lvns->latitude  = lvns->latitude_dark;
		} else {
			LvnsDarken(lvns);
		}
		LvnsDispWindow(lvns);
		LvnsFlip(lvns, True); // ƱΤ
	}
}

/**
 * طʤȥ饯ξ֤ɽ
 * ɽ夷Ф餯Ԥ
 */
void
LvnsDisp(Lvns *lvns, LvnsEffectType effect)
{
	/* BGM ѹå */
	LvnsStartNextMusic(lvns);

	/* طʥեȻ */
	if (lvns->effect_back_next) {
		lvns->effect_back = lvns->effect_back_next;
		lvns->effect_back_next = NULL;
	}

	/* VRAM */
	lvnsimage_copy(lvns->background, lvns->vram);
	LVNS->mergeCharacter(lvns);

	/* ԥĴɽʤѥåȽ */
	if (lvns->sepia_mode) {
	  lvnsimage_set_sepia(lvns->vram);
	}

	if (lvns->skip) {
		LvnsDispWindow(lvns);
	} else {
		LvnsDispLow(lvns, effect);
		LvnsWait(lvns, 500 * INTERVAL / 1000);
	}
}

/** 
 * õԤ
 * 
 */
void
LvnsClear(Lvns *lvns, LvnsEffectType effect) 
{
	if (lvns->skip) {
		lvnsimage_clear(lvns->vram);
		LvnsDispWindow(lvns);
	} else {
		LvnsClearLow(lvns, effect);
	}
	LvnsSetBackEffect(lvns, NULL);
}

/**
 * ľܥƥ
 */
void
LvnsDrawString(Lvns *lvns, int x, int y, const u_char *str, int attr)
{
    int code;  
    while (*str) {
        code = ((str[0]&0x7f)-33) * 94 + (str[1]&0x7f)-33;
        code = lvns->jis_to_leaf[code];
		if (code)
			LVNS->drawChar(lvns, x, y, code, attr);
        str += 2;
        x += CHARSIZE;
    }
}

/*
 * ľܥƥ(󥿥)
 */
void
LvnsDrawStringCenter(Lvns *lvns, int y, const u_char *str, int attr)
{
	LvnsDrawString(lvns, (WIDTH - strlen(str)/2 * CHARSIZE)/2,
				   y, str, attr);
}

void
LvnsTextOff(Lvns *lvns)
{
	lvns->text_mode = False;
}

void
LvnsTextOn(Lvns *lvns)
{
	lvns->text_mode = True;
}
